<template>
  <div id="app" class="h-full" :class="darkMode ? 'dark bg-bgdprim' : 'bg-bglsec'">
    <div class="fixed top-40 z-40 left-0 text-white">{{ $store.state.auth.mobiletest }}</div>
    <div
      :class="[
        darkMode ? 'dark bg-bgdprim' : 'bg-bglsec',
        isAdminPages ? 'p-0 no-scroll-width' : 'flex pr-44 p-8 sm:p-4 sm:pr-4 xs:pr-4 sm:pb-24 xs:pb-24 xs:p-4',
      ]"
      class="min-h-full gap-4 xl:gap-8 lg:gap-8 md:flex-col sm:flex-col xs:flex-col"
    >
      <TheStatistics
        v-if="!isAdminPages"
        :loading="analyticsLoading"
        class="app__statistics shrink-0 lg:sticky xl:sticky relative top-0 lg:top-8 xl:top-8"
        @update-timerange="handleUpdateTimerange"
      />
      <keep-alive :max="5" include="Index">
        <router-view style="min-width: 0" class="app__router-view flex-1 lg:min-h-full xl:min-h-full"></router-view>
      </keep-alive>
      <div
        v-if="!isAdminPages"
        class="sm:h-20 xs:h-20 w-28 sm:w-full xs:w-full fixed top-8 right-8 bottom-8 sm:top-unset xs:top-unset sm:right-0 sm:left-0 sm:bottom-0 xs:right-0 xs:left-0 xs:bottom-0"
      >
        <p v-if="$store.state.auth.mobileTest" class="text-white text-2xl fixed inset-0 m-auto">ETH exist</p>
        <ThePanel />
      </div>
    </div>

    <transition name="modal-appear">
      <AlmostThere v-show="almostThereDisplay" />
    </transition>
    <transition name="modal-appear">
      <TheConfigurator v-show="theConfiguratorDisplay" />
    </transition>
    <transition name="modal-appear">
      <ConnectModal v-show="connectModalDisplay" />
    </transition>
    <transition name="modal-appear">
      <AccountModal v-show="accountModalDisplay" />
    </transition>
    <transition name="modal-appear">
      <LanguageSelect v-show="languageSelectDisplay" />
    </transition>
    <transition name="modal-appear">
      <InvoiceModal v-show="invoiceModalDisplay" />
    </transition>
    <transition name="modal-appear">
      <InfoModal v-show="infoModalDisplay" />
    </transition>

    <ErrorPopup v-show="errorPopupDisplay" />

    <transition name="admin-popup">
      <AdminPopup v-if="isAdminPages" v-show="adminPopupDisplay" />
    </transition>
  </div>
</template>

<script lang="ts">
import { getAnalytics } from '@/api';
import Cookies from 'js-cookie';

import AlmostThere from '@/components/AlmostThere.vue';
import TheConfigurator from '@/components/the-configurator/TheConfigurator.vue';
import TheStatistics from '@/components/TheStatistics.vue';
import ThePanel from '@/components/ThePanel.vue';
import AccountModal from '@/components/AccountModal.vue';
import LanguageSelect from '@/components/LanguageSelect.vue';
import ErrorPopup from '@/components/ui/ErrorPopup.vue';
import ConnectModal from '@/components/ConnectModal.vue';
import AdminPopup from '@/components/ui/AdminPopup.vue';
import InvoiceModal from '@/components/InvoiceModal.vue';
import InfoModal from '@/components/InfoModal.vue';

export default {
  name: 'App',

  components: {
    AlmostThere,
    TheConfigurator,
    TheStatistics,
    ThePanel,
    ErrorPopup,
    ConnectModal,
    AccountModal,
    LanguageSelect,
    AdminPopup,
    InvoiceModal,
    InfoModal,
  },

  data() {
    return {
      timerange: {
        title: '1h',
        value: '1h',
      },

      analyticsInfo: {},
      analyticsLoading: false,
    };
  },

  computed: {
    darkMode() {
      return this.$store.state.system.darkMode;
    },

    almostThereDisplay() {
      return this.$store.state.system.almostThereDisplay;
    },

    theConfiguratorDisplay() {
      return this.$store.state.system.theConfiguratorDisplay;
    },

    errorPopupDisplay() {
      return this.$store.state.system.errorPopupDisplay;
    },

    connectModalDisplay() {
      return this.$store.state.system.connectModalDisplay;
    },

    accountModalDisplay() {
      return this.$store.state.system.accountModalDisplay;
    },

    languageSelectDisplay() {
      return this.$store.state.system.languageSelectDisplay;
    },

    isAuthorized() {
      return this.$store.state.auth.isAuthorized;
    },

    isAdminPages() {
      return this.$route.name === 'admin' || this.$route.name === 'admin-project';
    },

    adminPopupDisplay() {
      return this.$store.state.system.popupDisplay;
    },

    invoiceModalDisplay() {
      return this.$store.state.system.invoiceModalDisplay;
    },

    infoModalDisplay() {
      return this.$store.state.system.infoModalDisplay;
    },

    userProjects() {
      return this.$store.state.auth.userProjects;
    },

    currentApiKey() {
      return this.$store.state.auth.currentApiKey;
    },
  },

  watch: {
    currentApiKey(newVal) {
      this.getAnalytics(newVal);
    },

    'timerange.value'() {
      setTimeout(() => {
        this.getAnalytics(this.currentApiKey);
      }, 0);
    },
  },

  beforeCreate() {
    const token = Cookies.get('flashAuthToken');
    const walletKey = Cookies.get('flashWalletKey');

    if (token) this.$store.commit('setAuthToken', token);
    if (walletKey) this.$store.commit('setWalletKey', walletKey);
  },

  mounted() {
    if (this.$route.name !== 'endpoints') this.$store.commit('setCurrentApiKey', '');

    if (this.isAuthorized) {
      this.$store.dispatch('getAccountInfo');
    }

    setTimeout(() => {
      this.createGoogleTagScript();
      this.createGTMScript();
      this.createGoogleTagNoScript();
    }, 0);
  },

  methods: {
    checkLanguage() {
      const lang = Cookies.get('flashLang');
      if (!lang) return;
      this.$root.$i18n.locale = lang;
      if (lang === 'en') {
        this.$store.commit('setCurrentLang', { key: 'en', title: 'English' });
      } else {
        this.$store.commit('setCurrentLang', { key: 'cn', title: 'Chinese' });
      }
    },

    handleUpdateTimerange(value) {
      this.timerange = value;
    },

    async getAnalytics(key) {
      this.analyticsLoading = true;

      if (!this.isAuthorized || !key) {
        this.$store.commit('setAnalytics', { chart: [] });
        this.analyticsLoading = false;
        return;
      }

      try {
        const res = await getAnalytics({
          period: this.timerange.value,
          selector_value: key ? key : 'none',
          // selector_value: '3330b72d-ae3d-4e47-a7cd-bd11107740f7',
        });
        if (this.$route.name === 'endpoints') this.$store.commit('setAnalytics', res.data);
        else this.$store.commit('setAnalytics', { chart: [] });
      } catch (err) {
        this.$store.commit('setAnalytics', { chart: [] });
        console.error(err);
      } finally {
        this.analyticsLoading = false;
      }
    },

    createGoogleTagScript() {
      const head = document.querySelector('head');
      const script = document.createElement('script');
      script.innerText =
        'window.dataLayer = window.dataLayer || []; function gtag(){dataLayer.push(arguments);}gtag("js", new Date());gtag("config", "G-TP3BXYBNCQ");gtag("config", "AW-11048122678");';
      head.appendChild(script);
    },

    createGTMScript() {
      const head = document.querySelector('head');
      const script = document.createElement('script');
      script.innerText =
        '(function(w,d,s,l,i){w[l]=w[l]||[];w[l].push({"gtm.start":new Date().getTime(),event:"gtm.js"});var f=d.getElementsByTagName(s)[0],j=d.createElement(s),dl=l!="dataLayer"?"&l="+l:"";j.async=true;j.src="https://www.googletagmanager.com/gtm.js?id="+i+dl;f.parentNode.insertBefore(j,f);})(window,document,"script","dataLayer","GTM-NB2B24R");';
      head.appendChild(script);
    },

    createGoogleTagNoScript() {
      const noscript = document.createElement('noscript');
      const iframe = document.createElement('iframe');
      iframe.src = 'https://www.googletagmanager.com/ns.html?id=GTM-NB2B24R';
      iframe.height = '0';
      iframe.width = '0';
      iframe.style.display = 'none';
      iframe.style.visibility = 'hidden';
      noscript.appendChild(iframe);
      document.body.prepend(noscript);
    },
  },
};
</script>

<style lang="scss">
.app {
  &__statistics {
    @media (min-width: 1025px) {
      height: calc(100vh - 64px);
    }

    @media (min-width: 1025px) {
      width: 43.83%;
    }

    @media (max-width: 1024px) {
      height: 428px;
    }

    @media (max-width: 768px) {
      height: 396px;
    }

    @media (max-width: 600px) {
      height: 478px;
    }
  }
}

.admin-popup {
  &-enter-active,
  &-enter-active {
    transition: all 300ms cubic-bezier(0.03, 0.56, 0.11, 1.22);
  }

  &-enter {
    transform: translateX(120%);
  }
}
</style>
